
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>(cljs/run-at (JSVM. :all) &quot;一次说白DataType、Record和Protocol&quot;) / iVAN</title>

    <meta name="description" content="(cljs/run-at (JSVM. :all) &quot;一次说白DataType、Record和Protocol&quot;) 前言  在项目中我们一般会为实际问题域定义领域数据模型,譬如开发VDOM时自然而言就会定义个VNode数据类型,用于打包存储.操作相关数据.clj/cljs不单内置了List.Vector.Set和Map等数据结构,还提供deftype和defrecord让我们可以自定义数据结构,以满足实际开发需求. 定义数据结构从Data Type和Record开始  提及数据结构很自然就想起C语言中的struct,结构中只有字段并没有定义任何方法,而这也是deftype和defrecord最基础的玩法. 示">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">(cljs/run-at (JSVM. :all) &quot;一次说白DataType、Record和Protocol&quot;)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>前言</h1>
<p> 在项目中我们一般会为实际问题域定义领域数据模型，譬如开发VDOM时自然而言就会定义个VNode数据类型，用于打包存储、操作相关数据。clj/cljs不单内置了<code>List</code>、<code>Vector</code>、<code>Set</code>和<code>Map</code>等数据结构，还提供<code>deftype</code>和<code>defrecord</code>让我们可以自定义数据结构，以满足实际开发需求。</p>
<h2>定义数据结构从Data Type和Record开始</h2>
<p> 提及数据结构很自然就想起C语言中的struct，结构中只有字段并没有定义任何方法，而这也是<code>deftype</code>和<code>defrecord</code>最基础的玩法。<br />
示例</p>
<pre><code>(deftype VNode1 [tag props])
(defrecord VNode2 [tag props])

(def vnode1
  (VNode1. "DIV" {:textContent "Hello world!"}))
;; 或 (-&gt;VNode1 "DIV" {:textContent "Hello world!"})

(def vnode2
  (VNode2. "DIV" {:textContent "Hello world!"}))
;; 或 (-&gt;VNode2 "DIV" {:textContent "Hello world!"})
;; 或 (map-&gt;VNode2 {:tag "DIV", :props {:textContent "Hello world!"}})
</code></pre>
<p> 这样一看两者貌似没啥区别，其实区别在于成员的操作上</p>
<pre><code>;; deftype取成员值
(.-tag vnode1) ;;=&gt; DIV
;; defrecord取成员值
(:tag vnode2)  ;;=&gt; DIV

;; deftype修改成员值
(set! (.-tag vnode1) "SPAN")
;; 而 (aset vnode1 "tag" "SPAN")，这种方式不会改变vnode1的值
(.-tag vnode1) ;;=&gt; SPAN

;; defrecord无法修改值，只能产生一个新实例
(def vnode3
  (assoc vnode2 :tag "SPAN"))
(:tag vnode2) ;;=&gt; DIV
(:tag vnode3) ;;=&gt; SPAN
</code></pre>
<p> 从上面我们可以看到<code>defrecord</code>定义的数据结构可以视作Map来操作，而<code>deftype</code>则不能。<br />
 但上述均为术，而背后的道则是:<br />
在OOP中我们会建立两类数据模型：1.编程领域模型；2.应用领域模型。对于编程领域模型(如String等)，我们可以采用<code>deftype</code>来定义，从而提供特殊化能力；但对于应用领域模型而言，我们应该对其进行抽象，从而采用已有的工具（如<code>assoc</code>,<code>filter</code>等）对其进行加工，并且对于应用领域模型而言，一切属性应该均是可被访问的，并不存在私有的需要，因为一切属性均为不可变的哦。</p>
<h2>Protocol</h2>
<p> Protocol如同Interface可以让我们实施面对接口编程。上面我们通过<code>deftype</code>和<code>defrecord</code>我们可以自定义数据结构，其实我们可以通过实现已有的Protocol或自定义的Protocol来扩展数据结构的能力。</p>
<h3><code>deftype</code>和<code>defrecord</code>在定义时实现Protocol</h3>
<pre><code>;; 定义protocol IA
(defprotocol IA
  (println [this])
  (log [this msg]))

;; 定义protocol IB
(defprotocol IB
  (print [this]
         [this msg]))

;; 定义数据结构VNode并实现IA和IB
(defrecord VNode [tag props]
  IA
  (println [this]
    (println (:tag this)))
  (log [this msg]
    (println msg ":" (:tag this)))
  IB
  (print ([this]
    (print (:tag this)))))

;; 各种调用
(def vnode (VNode. "DIV" {:textContent "Hello!"}))
(println vnode)
(log vnode "Oh-yeah:")
(print vnode)
</code></pre>
<p>注意<code>IB</code>中定义print为Multi-arity method，因此实现中即使是仅仅实现其中一个函数签名，也要以Multi-arity method的方式实现。</p>
<pre><code>(print ([this] (print (:tag this))))
</code></pre>
<p>否则会报<code>java.lang.UnsupportedOperationException: nth not supported on this type: Symbol</code>的异常</p>
<h3>对已有的数据结构追加实现Protocol</h3>
<p> Protocol强大之处就是我们可以在运行时扩展已有数据结构的行为，其中可通过<code>extend-type</code>对某个数据结构实现多个Protocol，通过<code>extend-protocol</code>对多个数据结构实现指定Protocol。<br />
1.使用<code>extend-type</code></p>
<pre><code>;; 扩展js/NodeList，让其可转换为seq
(extend-type js/NodeList
  ISeqable
  (-seq [this]
    (let [l (.-length this)
          v (transient [])]
      (doseq [i (range l)]
        (-&gt;&gt; i
          (aget this)
          (conj! v)))
      (persistent! v))))
;; 使用
(map
  #(.-textContent %)
  (js/document.querySelector "div"))

;; 扩展js/RegExp，让其可直接作为函数使用
(extend-type js/RegExp
  IFn
  (-invoke ([this s]
    (re-matches this s))))

;; 使用
(#"s.*" "some") ;;=&gt; some
</code></pre>
<p>2.使用<code>extend-protocol</code></p>
<pre><code>;; 扩展js/RegExp和js/String，让其可直接作为函数使用
(extend-protocol IFn
  js/RegExp
  (-invoke ([this s] (re-matches this s)))
  js/String
  (-invoke ([this n] (clojure.string/join (take n this)))))

;; 使用
(#"s.*" "some") ;;=&gt; some
("test" 2) ;;=&gt; "te"
</code></pre>
<p> 另外我们可以通过<code>satisfies?</code>来检查某数据类型实例是否实现指定的Protocol</p>
<pre><code>(satisfies? IFn #"test") ;;=&gt; true
;;对于IFn我们可以直接调用Ifn?
(Ifn? #"test") ;;=&gt;true
</code></pre>
<h3><code>reify</code>构造实现指定Protocol的无属性实例</h3>
<pre><code>(defn user
  [firstname lastname]
  (reify
    IUser
    (full-name [_] (str firstname lastname))))
;; 使用
(def me (user "john" "Huang"))
(full-name me) ;;=&gt; johnHuang
</code></pre>
<h3><code>specify</code>和<code>specify!</code>为实例追加Protocol实现</h3>
<p><code>specify</code>可为不可变(immutable)和可复制(copyable，实现了ICloneable)的值，追加指定的Protocol实现。其实就是向cljs的值追加啦！</p>
<pre><code>(def a "johnHuang")
(def b (specify a
         IUser
         (full-name [_] "Full Name")))

(full-name a) ;;=&gt;报错
(full-name b) ;;=&gt;Full Name
</code></pre>
<p><code>specify!</code>可为JS值追加指定的Protocol实现</p>
<pre><code>(def a #js {})
(specify! a
  IUser
  (full-name [_] "Full Name"))

(full-name a) ;;=&gt; "Full Name"
</code></pre>
<h2>总结</h2>
<p> cljs建议对数据结构进行抽象，因此除了List,Map,Set,Vector外还提供了Seq；并内置一系列数据操作的函数，如map,filter,reduce等。而deftype、defrecord更多是针对面向对象编程来使用，或者是面对内置操作不足以描述逻辑时作为扩展的手段。也正是<code>deftype</code>,<code>defrecord</code>和<code>defprotocol</code>让我们从OOP转FP时感觉更加舒坦一点。<br />
 另外<code>deftype</code>,<code>defrecord</code>和protocol这套还有效地解决Expression Problem，具体请查看<a href="http://www.ibm.com/developerworks/library/j-clojure-protocols/" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/library/j-clojure-protocols/</a></p>
<p>尊重原创，转载请注明来自：<a href="http://www.cnblogs.com/fsjohnhuang/p/7154085.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fsjohnhuang/p/7154085.html</a> ^_^肥仔John</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-09 10:16:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%b1%bb%e5%9e%8b/" title="数据类型">数据类型</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b/" title="编程">编程</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/%e9%a2%86%e5%9f%9f%e6%a8%a1%e5%9e%8b/" title="领域模型">领域模型</a>, <a href="https://www.iamivan.net/tag/clojurescript/" title="clojurescript">clojurescript</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>(cljs/run-at (JSVM. :all) &quot;一次说白DataType、Record和Protocol&quot;)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlj5Yz.html" rel="bookmark">怎么用javascript进行拖拽</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript Javascript的特点是dom的处理与网页效果,大多数情况我们只用到了这个语言的最简单的功能,比如制作图片轮播/网页的tab等等,这篇文章将向你展示如何在自己的网页上制作拖拽． 有很多理由让你的网站加入拖拽功能,最简单的一个是数据重组．例如:你有一个序列的内容让用户排序,用户需要给每个条目进行输入或者用select选择,替代前面这个方法的就是拖拽．或许你的网站也需要一个用户可以拖动的导航窗口!那么这些效果都是很简单:因为你可以很容易的实现! 网页上实现拖拽其实也不是很复			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmQ3wp.html" rel="bookmark">在RichTextBox控件加入图片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				控件 using System;using System.Collections.Specialized;using System.Drawing;using System.Drawing.Imaging;using System.IO;using System.Runtime.InteropServices;using System.Text;using System.Windows.Forms; namespace Khendys.Controls {  #region Public Enu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWAqWp.html" rel="bookmark">uboot2011&period;09源代码ReadMe译文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				# # (C) Copyright 2000 - 2011 # Wolfgang Denk, DENX Software Engineering, wd@denx.de. #查看建立这个工程的文件列表人 # #这个程序是自由软件,你可以重新分配它或者修改它在GNU通用公共许可证以由自由软件基#金会发布:第二版或者任何之后的版本. #本程序是分布在希望它是有用的,但没有任何保证:甚至没有隐含保证. #查看 GNU通用公共许可证对于更多的细节. #你应该收到一份GNU通用公共许可证随着这个程序:如果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6443z.html" rel="bookmark">uwsgi配置了解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				uwsgi -&gt; python php-fpm -&gt; php PS: 很多东西很久不用,之前又不熟练,就容易忘!我这里只是备份下,万一原文没了,还可以参考下,直接看原文比较给力. How to Deploy Python WSGI Applications Using uWSGI Web Server with Nginx Dec 11, 2013 Python, Miscellaneous, Nginx CentOS Introduction As introduced in our Pyt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32lo3z.html" rel="bookmark">iOS开发系列--Objective-C之协议、代码块、分类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 ObjC的语法主要基于smalltalk进行设计的,除了提供常规的面向对象特性外,还增加了很多其他特性,这一节将重点介绍ObjC中一些常用的语法特性.当然这些内容虽然和其他高级语言命名不一样,但是我们都可以在其中找到他们的影子,在文章中我也会对比其他语言进行介绍,这一节的重点内容如下: 协议protocol 代码块block 分类category 协议protocol 在ObjC中使用@protocol定义一组方法规范,实现此协议的类必须实现对应的方法.熟悉面向对象的童鞋都知道接口本身是对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8A78lz.html" rel="bookmark">你应该知道如何跨域</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 转眼就是秋招季啦.经历了几场笔试面试,屡次被问到关于如何实现跨域.老实说,之前都是纸上谈兵,也没有项目需要跨域,甚至觉得这个东西没什么意义.直到今天项目中遇到了跨域问题,看了不少资料才理解跨域的普遍性和意义.特写此篇文章整理自己所得. 转自个人博客: 关于跨域 什么是跨域 一般来说,如果你在开发中需要进行跨域操作(从一个非同源网站发送请求获取数据),一般而言,你在浏览器控制台看到的结果为: XMLHttpRequest cannot load http://external-domain/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx2GLmz.html" rel="bookmark">拖动Html元素集合 Drag and Drop any item&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;style content=&quot;text/css&quot;&gt; li {   MARGIN-BOTTOM: 10px } ul {   MARGIN-TOP: 5px } .DragContainer {   BORDER-RIGHT: #669999 2px solid; PADDING-RIGHT: 5px; BORDER-TOP: #669999 2px solid; PADDING-LEFT: 5px; FLOAT: left; PADDING-BOTTOM: 0px; MA			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z72VkKp.html" rel="bookmark">&lpar;cljs&sol;run-at &lpar;JSVM&period; &colon;browser&rpar; &amp;quot&semi;简单类型可不简单啊～&amp;quot&semi;&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言  每逢学习一个新的语言时总要先了解这门语言支持的数据类型,因为数据类型决定这门语言所针对的问题域,像Bash那样内置只支持字符串的脚步明显就是用于文本处理啦.而数据类型又分为标量类型(Scalar).结构类型(Struct)和集合类型(Collection),标题中的简单类型实质就是指标量类型.  cljs中内置的标量类型比js的丰富得多,一方面方便了操作,另一个方面增加了学习成本,因此从js转向cljs时可能会略感不适,下面我们一起来认识吧! 标量类型一览 ;; 空值/空集 nil ;;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0WjPJb.html" rel="bookmark">&lpar;cljs&sol;run-at &lpar;JSVM&period; &colon;browser&rpar; &amp;quot&semi;命名空间就这么简单&amp;quot&semi;&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言  一个cljs文件定义一个命名空间,通过命名空间可以有效组织代码,这是构建大型系统必备的基础设施.本篇我们就深入理解cljs中的命名空间吧! 好习惯从&quot;头&quot;开始 每个cljs文件首行非注释的内容必定如下 (ns my-project.core) 而当前的cljs文件路径为${project_dir}/src/my_project/core.cljs,很明显命名空间与源码文件路径是一一对应的,对应规则是-对应_,.对应/咯~ 引入其他命名空间  要使用其他命名空间下的成员,那么必须			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAoKz3.html" rel="bookmark" class="title">JAVA程序员面试32问 选择自 liujun999999 的 Blog （本人做收藏）</a>
					<div>
						程序|程序员 第一,谈谈final, finally, finalize的区别. 第二,Anonymous Inner Class (匿名内部类) 是否可以extends(继承)其它类,是否可以imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgmG5z.html" rel="bookmark" class="title">基于Ajax的Web框架Echo2 2&period;0 正式发布</a>
					<div>
						ajax|web 基于Ajax的Web框架Echo2 近日宣布新版2.0正式发布. ECHO2是一个基于Mozilla Public License的开源WEB框架.它采用全新的AJAX(Asynch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM99NgM.html" rel="bookmark" class="title">PHP实现加密解密算法</a>
					<div>
						PHP实现加密解密的算法,如下代码: &lt;?php    class Mcrypt    {        /**        * 解密        *         * @param st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2EQoz.html" rel="bookmark" class="title">ASP&period;NET ListView控件学习系列2-编辑ListView（Edit&comma;Update&comma;Insert&comma;Delete）</a>
					<div>
						一.编辑,取消,更新操作 首先拖一个ListView控件到页面,然后按如下代码进行调整,这里为了利用ListView控件中按钮的内置功能CommandName必须和我们这里的名字一样 前端代码 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg2XAb.html" rel="bookmark" class="title">Delphi GDI&plus; 学习记录&lpar;23&rpar;&colon; 输出文本&amp;amp&semi;lt&semi;2&amp;amp&semi;gt&semi;</a>
					<div>
						//在矩形范围中显示文本var g: TGPGraphics; fontFamily: TGPFontFamily; font: TGPFont; rectF: TGPRectF; p: TGPPen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLJORb.html" rel="bookmark" class="title">MS SQL基础教程：注册服务器</a>
					<div>
						在SQL Server 中可以使用注册向导和注册属性对话框两种方式来注册服务器.注册过程如下: (1) 在Enterprise Manager 的菜单中选择操作(Action) 菜单,从Action  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62jeXM.html" rel="bookmark" class="title">Dreaweaver 8&period;0实现文本段落缩进的方法</a>
					<div>
						  我们在用Dreaweave书写英文文本时,段落一般不缩进(不支持半角空格);但我们大多的时候都是用中文书写格式,必须在每段开头空两个汉字的位置.但浏览器对于文本中的空格,不管多少只认一个空格. 如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRqQZp.html" rel="bookmark" class="title">谷歌的AI大神Hinton揭开了神经网络的新面纱</a>
					<div>
						如果你想指责某人在人工智能方面的大肆宣传,69岁的谷歌研究员,同时也是深度学习教父的Geoff Hinton是一个很好的候选人. 如今,神经网络转录我们的语音,识别我们的宠物,甚至可以预测病人的患病程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24vxop.html" rel="bookmark" class="title">javaer to go之mysql操作</a>
					<div>
						经过度娘后,发现比较常用golang mysql驱动包有两种mymysql和go-sql-driver/mysql.个人觉得mymysql这个名字起得不够文雅.所以我选择了go-sql-driver/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6ROqz.html" rel="bookmark" class="title">利用JS获取JWplayer 播放状态</a>
					<div>
						问题描述 怎么获取播放器的播放时间.比如播放到6分钟,就弹出登陆注册.&lt;divid=&quot;container&quot;&gt;Loadingtheplayer...&lt;/div&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7J0Pp.html" rel="bookmark" class="title">Gradle构建多模块项目</a>
					<div>
						废话不多说,直接进入主题. 1. 创建项目 首先创建项目,名称为 test: mkdir test &amp;&amp; cd test gradle init 这时候的项目结构如下: test tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEG0Bp.html" rel="bookmark" class="title">linq-link关于课程表的问题，要求同样的课连续上，如何修改如下代码？</a>
					<div>
						问题描述 link关于课程表的问题,要求同样的课连续上,如何修改如下代码? using System;using System.Collections.Generic;using System.Lin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32xvWz.html" rel="bookmark" class="title">杨强：从&OpenCurlyDoubleQuote;互联网&plus;&rdquo;到&OpenCurlyDoubleQuote;&plus;人工智能&rdquo;</a>
					<div>
						2015年8月14日,由中国科协.中国科学院指导,中国人工智能学会发起主办的第五届中国智能产业高峰论坛在上海长荣桂冠酒店顺利召开. 摘要所谓&quot;深度+&quot;是通过大数据来产生这种,我们所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Ry3vb.html" rel="bookmark" class="title">驻云科技完成C轮近亿元融资 成为撬起云计算的&OpenCurlyDoubleQuote;支点&rdquo;</a>
					<div>
						除了解读稿之外,你还可以看到驻云发布会现场实时直播 驻云获得C轮近亿元融资 6月8日,阿里云使命级合作伙伴.国内云服务行业标准制定者上海驻云信息科技有限公司,在上海浦东新区博雅酒店成功举行&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBgnvb.html" rel="bookmark" class="title">listview中的adapter学习小结</a>
					<div>
						概述 Adapter是数据和UI之间的一个桥梁,在listview,gridview等控件中都会使用到,Android给我们提拱了4个adapte供我们使用: BaseAdapter是一个抽象类,继承 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRQq2p.html" rel="bookmark" class="title">&period;cn顶级域名遭殃 流量攻击已成黑色产业链</a>
					<div>
						8月25日凌晨,中国互联http://www.aliyun.com/zixun/aggregation/32420.html&quot;&gt;网络信息中心管理运行的国家.CN顶级域名系统遭受大规模拒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5ay7p.html" rel="bookmark" class="title">freerdp windows-freerdp代码在windows下的编译XP系统不适用</a>
					<div>
						问题描述 freerdp代码在windows下的编译XP系统不适用 我在freerdp下载了源码,用cmake生成了VS2010的代码,经过编译成功后,生成的wfreerdp.exe在win7 win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YoBPz.html" rel="bookmark" class="title">帮忙翻译个Java线程（伪代码翻译成Java线程）</a>
					<div>
						问题描述 Initialize()ReadEventPlayerFile()//ReadintheEventPlayerFileandstorein//Memory(iffilesdoesnotget ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5Jjkz.html" rel="bookmark" class="title">div随屏幕滚动JS程序代码</a>
					<div>
						 代码如下 复制代码 var tips; var theTop = 250/*这是默认高度*/; var old = theTop; function initFloatTips() {    tip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZDZmz.html" rel="bookmark" class="title">Javascript 按位取反运算符一些详解</a>
					<div>
						对一个表达式执行位非(求非)运算. result = ~ expression 参数 result 任何变量. expression 任何表达式. 备注   所有一元运算符(如 ~ 运算符)都按照下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmrlAz.html" rel="bookmark" class="title">JavaScript在for循环中绑定事件解决事件参数不同的情况&lowbar;javascript技巧</a>
					<div>
						有时候要对响应一堆相似的事件,但是每个事件的参数都不同,一开始还以为挺简单的,用个for循环不就得了,结果发现,额,都是使用了最后一个参数... 上网查资料!!!结果大神说用闭包解决 代码: 复制代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr7KOp.html" rel="bookmark" class="title">《法人》杂志：诺基亚大难临头</a>
					<div>
						与其说诺基亚是败给了对手的如潮攻势,倒不如说诺基亚败给了自己.其长年积累下高处不胜寒的寂寞侵吞了诺基亚对市场的敏感嗅觉 文 曾高飞 物极必反,盛极而衰.强大如诺基亚,都没能逃过这句魔咒的怪圈.在经历了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0wQNp.html" rel="bookmark" class="title">ReaderDll&lowbar;CE&period;dll</a>
					<div>
						问题描述 PDAC#找不到这个是什么问题?大神??? 解决方案 解决方案二:那没找到,就是没找到,你看看你的程序里是不是缺少这个文件,或者这个文件是要放到特定的什么目录下才能行的.解决方案三:把dll ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Ql4ap.html" rel="bookmark" class="title">&period;net 网站 经常出现 &rdquo;无效的视图状态&OpenCurlyDoubleQuote;</a>
					<div>
						问题描述 日期时间:2014-12-1010:47:15IP:220.181.42.195上一路径:http://www.xxx.com/ShopPay.aspx当前路径:http://www.xxx ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyrBdM.html" rel="bookmark" class="title">JavaScript html5 canvas绘制时钟效果&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JavaScript+html5 canvas绘制时钟效果.分享给大家供大家参考,具体如下:  HTML部分: &lt;!DOCTYPE html&gt; &lt;html lang=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1DLjdb.html" rel="bookmark" class="title">做水晶报表时候遇到 key Error&lowbar;InvalidServer，不知怎么解决ing</a>
					<div>
						问题描述 java.util.MissingResourceException:Can'tfindresourceforbundlejava.util.PropertyResourceBundle,k ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4qXob.html" rel="bookmark" class="title">周鸿祎重做路由器，到底在做什么？</a>
					<div>
						    沉寂一年后,360开始养成用&quot;内部&quot;信做新业务动员令的习惯.1月9日晚十点,在工作日和休息日交接的时分,360董事长周鸿祎发出了他在新旧年交接的第三封&quot;内部&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqYXab.html" rel="bookmark" class="title">两化融合：唐山探路重工业城市智慧转型</a>
					<div>
						坐拥雄厚的工业基础和工业文明,素有&quot;煤都钢城&quot;之称的唐山,曾诞生了全国第一座机械化采煤矿井.第一条标准轨距铁路.第一桶机制水泥.第一件卫生陶瓷--而现在,时光荏苒,过去令唐山引以为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boOv0Xb.html" rel="bookmark" class="title">C&num;高级编程&lpar;第三版&rpar;下载34&period;97 MB&lpar;最好用迅雷下&rpar;</a>
					<div>
						问题描述 C#高级编程(第三版)下载34.97MB(最好用迅雷下)下载地址: 解决方案 解决方案二:看大小估计是扫描版本的,不过还是谢谢LZ的分享.解决方案三:速度不错,谢谢					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeL8o0p.html" rel="bookmark" class="title">美国网络投资骗局华裔受害者俱增 或多达数百人</a>
					<div>
						原标题 美国网络投资骗局华裔受害者俱增 或多达数百人 中新网1月15日电&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
